/********************* ROLES **********************/

/********************* UDFS ***********************/

/****************** GENERATORS ********************/

CREATE GENERATOR RECORDID_GENERATOR;
/******************** DOMAINS *********************/

CREATE DOMAIN DOMAIN_RECORDID
 AS Integer
;
CREATE DOMAIN DOMAIN_RECORDSTATUS
 AS Varchar(1)
 COLLATE NONE;
CREATE DOMAIN DOMAIN_TIMESTAMPCHANGE
 AS Timestamp
;
CREATE DOMAIN DOMAIN_TIMESTAMPENTRY
 AS Timestamp
;
CREATE DOMAIN DOMAIN_UOC
 AS Varchar(8)
 COLLATE NONE;
CREATE DOMAIN DOMAIN_UOE
 AS Varchar(8)
 COLLATE NONE;
CREATE DOMAIN DOMAIN_USERID
 AS Varchar(20)
 COLLATE NONE;
/******************* PROCEDURES ******************/

SET TERM ^ ;
CREATE PROCEDURE DELETELUDEPARTMENTS (
    RECORDID Integer,
    UOC Varchar(20) )
RETURNS (
    RETURNMESSAGE Varchar(255) )
AS
BEGIN SUSPEND; END^
SET TERM ; ^

SET TERM ^ ;
CREATE PROCEDURE DELETELUMANUFACTURERCPUSPEEDS (
    RECORDID Integer,
    UOC Varchar(20) )
RETURNS (
    RETURNMESSAGE Varchar(255) )
AS
BEGIN SUSPEND; END^
SET TERM ; ^

SET TERM ^ ;
CREATE PROCEDURE FETCHLUDEPARTMENTS (
    RECORDID Integer )
RETURNS (
    CODE Varchar(3),
    DESCRIPTION Varchar(40),
    RECORDSTATUS Varchar(1),
    UOE Varchar(20),
    DOE Timestamp,
    UOC Varchar(20),
    DOC Timestamp )
AS
BEGIN SUSPEND; END^
SET TERM ; ^

SET TERM ^ ;
CREATE PROCEDURE FETCHLUMANUFACTURERCPUSPEEDS (
    RECORDID Integer )
RETURNS (
    MANUFACTURERCPUSPEED Varchar(60),
    RECORDSTATUS Varchar(1),
    UOE Varchar(20),
    DOE Timestamp,
    UOC Varchar(20),
    DOC Timestamp )
AS
BEGIN SUSPEND; END^
SET TERM ; ^

SET TERM ^ ;
CREATE PROCEDURE INSERTLUDEPARTMENTS (
    CODE Varchar(3),
    DESCRIPTION Varchar(40),
    RECORDSTATUS Varchar(1),
    UOE Varchar(20) )
RETURNS (
    RETURNMESSAGE Varchar(255) )
AS
BEGIN SUSPEND; END^
SET TERM ; ^

SET TERM ^ ;
CREATE PROCEDURE INSERTLUMANUFACTURERCPUSPEEDS (
    MANUFACTURERCPUSPEED Varchar(60),
    RECORDSTATUS Varchar(1),
    UOE Varchar(20) )
RETURNS (
    RETURNMESSAGE Varchar(255) )
AS
BEGIN SUSPEND; END^
SET TERM ; ^

SET TERM ^ ;
CREATE PROCEDURE SELECTLUDEPARTMENTS
RETURNS (
    CODE Varchar(3),
    DESCRIPTION Varchar(40),
    RECORDSTATUS Varchar(1),
    UOE Varchar(20),
    DOE Timestamp,
    UOC Varchar(20),
    DOC Timestamp,
    RECORDID Integer )
AS
BEGIN SUSPEND; END^
SET TERM ; ^

SET TERM ^ ;
CREATE PROCEDURE SELECTLUMANUFACTURERCPUSPEEDS
RETURNS (
    MANUFACTURERCPUSPEED Varchar(60),
    RECORDSTATUS Varchar(1),
    UOE Varchar(20),
    DOE Timestamp,
    UOC Varchar(20),
    DOC Timestamp,
    RECORDID Integer )
AS
BEGIN SUSPEND; END^
SET TERM ; ^

SET TERM ^ ;
CREATE PROCEDURE UPDATELUDEPARTMENTS (
    RECORDID Integer,
    CODE Varchar(3),
    DESCRIPTION Varchar(40),
    RECORDSTATUS Varchar(1),
    UOC Varchar(20) )
RETURNS (
    RETURNMESSAGE Varchar(255) )
AS
BEGIN SUSPEND; END^
SET TERM ; ^

SET TERM ^ ;
CREATE PROCEDURE UPDATELUMANUFACTURERCPUSPEEDS (
    RECORDID Integer,
    MANUFACTURERCPUSPEED Varchar(60),
    RECORDSTATUS Varchar(1),
    UOC Varchar(20) )
RETURNS (
    RETURNMESSAGE Varchar(255) )
AS
BEGIN SUSPEND; END^
SET TERM ; ^

SET TERM ^ ;
CREATE PROCEDURE VALIDATELUDEPARTMENTS (
    CODE Varchar(3),
    DESCRIPTION Varchar(40),
    RECORDSTATUS Varchar(1),
    USERID Varchar(20) )
RETURNS (
    RETURNMESSAGE Varchar(255) )
AS
BEGIN SUSPEND; END^
SET TERM ; ^

SET TERM ^ ;
CREATE PROCEDURE VALIDATELUMANUFACTURERCPUSPEEDS (
    MANUFACTURERCPUSPEEDS Varchar(60),
    RECORDSTATUS Varchar(1),
    USERID Varchar(20) )
RETURNS (
    RETURNMESSAGE Varchar(255) )
AS
BEGIN SUSPEND; END^
SET TERM ; ^

SET TERM ^ ;
CREATE PROCEDURE VALIDATERECORDSTATUS (
    RECORDSTATUS Varchar(1) )
RETURNS (
    RETURNMESSAGE Varchar(255) )
AS
BEGIN SUSPEND; END^
SET TERM ; ^

SET TERM ^ ;
CREATE PROCEDURE VALIDATEVARCHARFIELDASNOTBLANK (
    FIELDTOVALIDATE Varchar(255),
    FIELDNAME Varchar(80) )
RETURNS (
    RETURNMESSAGE Varchar(255) )
AS
BEGIN SUSPEND; END^
SET TERM ; ^

/******************** TABLES **********************/

CREATE TABLE COMPUTERS
(
  RECORDID DOMAIN_RECORDID NOT NULL,
  DIVISION Varchar(3),
  DEPARTMENT Varchar(3),
  "TYPE" Varchar(2),
  LOCATION Varchar(30),
  COMPUTERNAME Varchar(20) NOT NULL,
  MANUFACTURERCPUSPEED Varchar(60),
  MEMORY Integer,
  HARDDISK Integer,
  MONITORSIZE Integer,
  OS Varchar(20),
  USERNAME Varchar(60),
  DATEOFPURCHASE Timestamp,
  COST Integer,
  SERIALNUMBER Varchar(15),
  AVAILABLEFORSURPLUS Varchar(1),
  GHOSTIMAGENAME Varchar(60),
  UOE DOMAIN_USERID,
  DOE DOMAIN_TIMESTAMPENTRY,
  UOC DOMAIN_USERID,
  DOC DOMAIN_TIMESTAMPCHANGE,
  IPADDRESS Varchar(20),
  NOTE Varchar(4000),
  DATEAUDITED Timestamp,
  SERVERHARDDRIVEARRAYSIZE Varchar(20),
  ARRAYCONFIGURATION Varchar(6),
  ARRAYWARRANTYINFO Varchar(80),
  RECORDSTATUS DOMAIN_RECORDSTATUS,
  CONSTRAINT PK_COMPUTERS PRIMARY KEY (RECORDID)
);
CREATE TABLE COMPUTERSSOFTWARE
(
  RECORDID DOMAIN_RECORDID NOT NULL,
  COMPUTERSRECORDID DOMAIN_RECORDID,
  SOFTWARENAME Varchar(50),
  UOE DOMAIN_UOE,
  DOE DOMAIN_TIMESTAMPENTRY,
  UOC DOMAIN_UOC,
  DOC DOMAIN_TIMESTAMPCHANGE,
  RECORDSTATUS DOMAIN_RECORDSTATUS,
  CONSTRAINT PK_COMPUTERSSOFTWARE PRIMARY KEY (RECORDID)
);
CREATE TABLE CONFIGURATIONS
(
  RECORDID DOMAIN_RECORDID NOT NULL,
  NAME Varchar(80) NOT NULL,
  WINDOWTITLE Varchar(80),
  WINDOWNAME Varchar(80),
  SORTINGORDER Varchar(255),
  FILTERSTATEMENT Varchar(1000),
  VCONSQLSNRECORDID DOMAIN_RECORDID,
  AUTOCLOSEWINDOWIFNORESULTSFOUND Varchar(1),
  NOTE Varchar(4000),
  DEFAULTRECORDIDFIELDNAME Varchar(80),
  UOE DOMAIN_USERID,
  DOE DOMAIN_TIMESTAMPENTRY,
  UOC DOMAIN_USERID,
  DOC DOMAIN_TIMESTAMPCHANGE,
  RECORDSTATUS DOMAIN_RECORDSTATUS,
  CONSTRAINT PK_CONFIGURATIONS PRIMARY KEY (NAME)
);
CREATE TABLE CONFIGURATIONSACTIONS
(
  RECORDID DOMAIN_RECORDID NOT NULL,
  CONRECORDID DOMAIN_RECORDID,
  TITLE Varchar(80),
  LOCATION Varchar(20),
  ACTIONTAKEN Varchar(80),
  HOTKEYVALUE Varchar(20),
  TOOLTIP Varchar(1000),
  NOTE Varchar(1000),
  RECORDIDFIELDNAME Varchar(80),
  DISABLEACTIONBUTTON Varchar(1),
  UOE DOMAIN_USERID,
  DOE DOMAIN_TIMESTAMPENTRY,
  UOC DOMAIN_USERID,
  DOC DOMAIN_TIMESTAMPCHANGE,
  RECORDSTATUS DOMAIN_RECORDSTATUS,
  DISABLEFORCINGSELECTION Varchar(1),
  ACTIONPARAMETERS Varchar(80),
  CONSTRAINT PK_CONFIGURATIONSACTIONS PRIMARY KEY (RECORDID)
);
CREATE TABLE CONFIGURATIONSFIELDMAPPING
(
  RECORDID DOMAIN_RECORDID NOT NULL,
  CONRECORDID DOMAIN_RECORDID,
  NOTE Varchar(1000),
  DISPLAYCOLUMNNUMBER Smallint,
  SELECTCOLUMNNUMBER Smallint,
  EXTRACTVALUEOPTION Varchar(60),
  COLUMNWIDTH Integer,
  COLUMNHEADER Varchar(60),
  JUSTIFICATION Varchar(10),
  UOE DOMAIN_USERID,
  DOE DOMAIN_TIMESTAMPENTRY,
  UOC DOMAIN_USERID,
  DOC DOMAIN_TIMESTAMPCHANGE,
  RECORDSTATUS DOMAIN_RECORDSTATUS,
  CONSTRAINT PK_CONFIGURATIONSFIELDMAPPING PRIMARY KEY (RECORDID)
);
CREATE TABLE CONFIGURATIONSUPDATEFORMS
(
  NAME Varchar(80) NOT NULL,
  WINDOWHEIGHT Integer,
  PROMPTCOLUMNWIDTH Integer,
  RECORDID DOMAIN_RECORDID,
  UOE DOMAIN_USERID,
  DOE DOMAIN_TIMESTAMPENTRY,
  UOC DOMAIN_USERID,
  DOC DOMAIN_TIMESTAMPCHANGE,
  RECORDSTATUS DOMAIN_RECORDSTATUS,
  CONSTRAINT PK_CONFIGURATIONSUPDATEFORMS PRIMARY KEY (NAME)
);
CREATE TABLE CONFIGURATIONUPDATEFORMFIELD
(
  CUFRECORDID DOMAIN_RECORDID,
  FIELDNAME Varchar(60),
  FIELDTYPE Varchar(20),
  FIELDWIDTH Integer,
  FIELDVALUEDESCRIPTIONVISIBLE Varchar(1),
  FIELDVALUEDESCRIPTION Varchar(255),
  FIELDVALUEDESCRIPTIONWIDTH Integer,
  FIELDPROMPT Varchar(80),
  VALIDATIONRULE Varchar(255),
  SEQUENCENUMBER Integer,
  FIELDPICTURE Varchar(20),
  LOOKUPBUTTONVISIBLE Varchar(1),
  LOOKUPBUTTONCALL Varchar(255),
  FIELDISREADONLY Varchar(1),
  FIELDTOOLTIP Varchar(10000),
  RECORDID DOMAIN_RECORDID NOT NULL,
  UOE DOMAIN_USERID,
  DOE DOMAIN_TIMESTAMPENTRY,
  UOC DOMAIN_USERID,
  DOC DOMAIN_TIMESTAMPCHANGE,
  RECORDSTATUS DOMAIN_RECORDSTATUS,
  CONSTRAINT PK_CONFIGURATIONSUFF PRIMARY KEY (RECORDID)
);
CREATE TABLE LUDEPARTMENTS
(
  CODE Varchar(3) NOT NULL,
  DESCRIPTION Varchar(40),
  RECORDID DOMAIN_RECORDID,
  UOE DOMAIN_USERID,
  DOE DOMAIN_TIMESTAMPENTRY,
  UOC DOMAIN_USERID,
  DOC DOMAIN_TIMESTAMPCHANGE,
  RECORDSTATUS DOMAIN_RECORDSTATUS,
  CONSTRAINT PK_LUDEPARTMENTS PRIMARY KEY (CODE)
);
CREATE TABLE LUDIVISIONS
(
  RECORDID DOMAIN_RECORDID NOT NULL,
  DIVISIONCODE Varchar(3) NOT NULL,
  DIVISIONDESCRIPTION Varchar(40) NOT NULL,
  DEPARTMENTCODE Varchar(3) NOT NULL,
  DEPTID Integer NOT NULL,
  UOE DOMAIN_USERID,
  DOE DOMAIN_TIMESTAMPENTRY,
  UOC DOMAIN_USERID,
  DOC DOMAIN_TIMESTAMPCHANGE,
  RECORDSTATUS DOMAIN_RECORDSTATUS,
  CONSTRAINT PK_LUDIVISIONS PRIMARY KEY (DIVISIONCODE)
);
CREATE TABLE LUGHOSTIMAGES
(
  IMAGENAME Varchar(60) NOT NULL,
  DIVISION Varchar(3),
  WHEREIMAGEISKEPT Varchar(80) NOT NULL,
  NOTES Varchar(3000),
  RECORDID DOMAIN_RECORDID,
  UOE DOMAIN_USERID,
  DOE DOMAIN_TIMESTAMPENTRY,
  UOC DOMAIN_USERID,
  DOC DOMAIN_TIMESTAMPCHANGE,
  RECORDSTATUS DOMAIN_RECORDSTATUS,
  CONSTRAINT PK_LUGHOSTIMAGES PRIMARY KEY (IMAGENAME)
);
CREATE TABLE LULOCATIONS
(
  LOCATION Varchar(30) NOT NULL,
  ASSETMANAGEMENTLOCATION Varchar(20),
  RECORDID DOMAIN_RECORDID,
  UOE DOMAIN_USERID,
  DOE DOMAIN_TIMESTAMPENTRY,
  UOC DOMAIN_USERID,
  DOC DOMAIN_TIMESTAMPCHANGE,
  RECORDSTATUS DOMAIN_RECORDSTATUS,
  CONSTRAINT PK_LULOCATIONS PRIMARY KEY (LOCATION)
);
CREATE TABLE LULOOKUPBUTTONCALL
(
  NOTE Varchar(10000),
  LOOKUPBUTTONCALL Varchar(255) NOT NULL,
  RECORDID DOMAIN_RECORDID,
  UOE DOMAIN_USERID,
  DOE DOMAIN_TIMESTAMPENTRY,
  UOC DOMAIN_USERID,
  DOC DOMAIN_TIMESTAMPCHANGE,
  RECORDSTATUS DOMAIN_RECORDSTATUS,
  CONSTRAINT PK_LULOOKUPBUTTONCALL PRIMARY KEY (LOOKUPBUTTONCALL)
);
CREATE TABLE LUMANUFACTURERCPUSPEEDS
(
  MANUFACTURERCPUSPEED Varchar(60) NOT NULL,
  RECORDID DOMAIN_RECORDID,
  UOE Varchar(20),
  DOE DOMAIN_TIMESTAMPENTRY,
  UOC Varchar(20),
  DOC DOMAIN_TIMESTAMPCHANGE,
  RECORDSTATUS DOMAIN_RECORDSTATUS,
  CONSTRAINT PK_LUMANUFACTURERCPUSPEEDS PRIMARY KEY (MANUFACTURERCPUSPEED)
);
CREATE TABLE LUOPERATINGSYSTEMS
(
  OPERATINGSYSTEM Varchar(20) NOT NULL,
  RECORDID DOMAIN_RECORDID,
  UOE Varchar(20),
  DOE DOMAIN_TIMESTAMPENTRY,
  UOC Varchar(20),
  DOC DOMAIN_TIMESTAMPCHANGE,
  RECORDSTATUS DOMAIN_RECORDSTATUS,
  CONSTRAINT PK_LUOPERATINGSYSTEMS PRIMARY KEY (OPERATINGSYSTEM)
);
CREATE TABLE LUSOFTWAREONPCSNAMES
(
  SOFTWARENAME Varchar(50) NOT NULL,
  RECORDID DOMAIN_RECORDID,
  UOE DOMAIN_UOE,
  DOE DOMAIN_TIMESTAMPENTRY,
  UOC DOMAIN_UOC,
  DOC DOMAIN_TIMESTAMPCHANGE,
  RECORDSTATUS DOMAIN_RECORDSTATUS,
  CONSTRAINT PK_LUSOFTWAREONPCSNAMES PRIMARY KEY (SOFTWARENAME)
);
CREATE TABLE LUVALIDATIONRULE
(
  NOTE Varchar(10000),
  VALIDATIONRULE Varchar(255) NOT NULL,
  RECORDID DOMAIN_RECORDID,
  UOE DOMAIN_USERID,
  DOE DOMAIN_TIMESTAMPENTRY,
  UOC DOMAIN_USERID,
  DOC DOMAIN_TIMESTAMPCHANGE,
  RECORDSTATUS DOMAIN_RECORDSTATUS,
  CONSTRAINT PK_LUVALIDATIONRULE PRIMARY KEY (VALIDATIONRULE)
);
CREATE TABLE OTHEREQUIPMENT
(
  RECORDID DOMAIN_RECORDID NOT NULL,
  DIVISION Varchar(3),
  DESCRIPTION Varchar(80),
  SERIALNUMBER Varchar(40),
  LOCATION Varchar(30),
  DATEPURCHASED Timestamp,
  EQUIPMENTTYPE Varchar(15),
  PURCHASECOST Integer,
  IPADDRESS Varchar(20),
  SYMQUESTNUMBER Varchar(10),
  IPNUMBER Varchar(20),
  NETWORKADDRESS Varchar(40),
  SHARENAME Varchar(60),
  PRINTERNAME Varchar(60),
  FEATURES Blob sub_type 1,
  DATEAUDITED Timestamp,
  UOE DOMAIN_USERID,
  DOE DOMAIN_TIMESTAMPENTRY,
  UOC DOMAIN_USERID,
  DOC DOMAIN_TIMESTAMPCHANGE,
  RECORDSTATUS DOMAIN_RECORDSTATUS,
  CONSTRAINT PK_OTHEREQUIPMENT PRIMARY KEY (RECORDID)
);
CREATE TABLE SQLTEMP
(
  F1 Varchar(255),
  F2 Varchar(255),
  F3 Varchar(255),
  F4 Varchar(255),
  F5 Varchar(255),
  F6 Varchar(255),
  F7 Varchar(255),
  F8 Varchar(255),
  F9 Varchar(255),
  F10 Varchar(255),
  F11 Varchar(255),
  F12 Varchar(255),
  F13 Varchar(255),
  F14 Varchar(255),
  F15 Varchar(255)
);
CREATE TABLE UPDATEFORMSLOOKS
(
  RECORDID DOMAIN_RECORDID NOT NULL,
  NAME Varchar(80) NOT NULL,
  CUFRECORDID DOMAIN_RECORDID,
  RECORDSTATUS DOMAIN_RECORDSTATUS,
  WINDOWHEIGHT Integer,
  PROMPTCOLUMNWIDTH Integer,
  CONSTRAINT PK_UPDATEFORMSLOOKS PRIMARY KEY (NAME)
);
CREATE TABLE UPDATEFORMSLOOKSFIELDS
(
  RECORDID DOMAIN_RECORDID NOT NULL,
  NAME Varchar(80),
  UPDATEFORMSLOOKSRECORDID DOMAIN_RECORDID,
  FIELDNAME Varchar(60),
  FIELDWIDTH Integer,
  FIELDVALUEDESCRIPTIONWIDTH Integer,
  SEQUENCENUMBER Integer,
  CONSTRAINT PK_UPDATEFORMSLOOKSFIELDS PRIMARY KEY (RECORDID)
);
CREATE TABLE VCONFSQLSELECTSTATEMENT
(
  RECORDID DOMAIN_RECORDID NOT NULL,
  NAME Varchar(80) NOT NULL,
  SQLSELECTCLAUSE Varchar(1000),
  SQLFROMCLAUSE Varchar(1000),
  SQLWHERECLAUSE Varchar(2000),
  NOTE Varchar(1000),
  UOE DOMAIN_USERID,
  DOE DOMAIN_TIMESTAMPENTRY,
  UOC DOMAIN_USERID,
  DOC DOMAIN_TIMESTAMPCHANGE,
  RECORDSTATUS DOMAIN_RECORDSTATUS,
  CONSTRAINT PK_VCONFSQLSELECTSTATEMENT PRIMARY KEY (NAME)
);
/********************* VIEWS **********************/

/******************* EXCEPTIONS *******************/

/******************** TRIGGERS ********************/

SET TERM ^ ;
CREATE TRIGGER RECORDIDCOMPUTERS FOR COMPUTERS INACTIVE
BEFORE INSERT POSITION 0
AS 
BEGIN 
 New.RECORDID=gen_id(RECORDID_GENERATOR,1);
END^
SET TERM ; ^
SET TERM ^ ;
CREATE TRIGGER RECORDIDCOMPUTERSSOFTWARE FOR COMPUTERSSOFTWARE ACTIVE
BEFORE INSERT POSITION 0
AS 
BEGIN 
 New.RECORDID=gen_id(RECORDID_GENERATOR,1);
END^
SET TERM ; ^
SET TERM ^ ;
CREATE TRIGGER RECORDIDLUDEPARTMENTS FOR LUDEPARTMENTS ACTIVE
BEFORE INSERT POSITION 0
AS 
BEGIN 
 New.RECORDID=gen_id(RECORDID_GENERATOR,1);
END^
SET TERM ; ^
SET TERM ^ ;
CREATE TRIGGER RECORDIDLUGHOSTIMAGES FOR LUGHOSTIMAGES ACTIVE
BEFORE INSERT POSITION 0
AS 
BEGIN 
 New.RECORDID=gen_id(RECORDID_GENERATOR,1);
END^
SET TERM ; ^
SET TERM ^ ;
CREATE TRIGGER RECORDIDLULOCATIONS FOR LULOCATIONS ACTIVE
BEFORE INSERT POSITION 0
AS 
BEGIN 
 New.RECORDID=gen_id(RECORDID_GENERATOR,1);
END^
SET TERM ; ^
SET TERM ^ ;
CREATE TRIGGER RECORDIDLUMANUFACTURERCPUSPEEDS FOR LUMANUFACTURERCPUSPEEDS ACTIVE
BEFORE INSERT POSITION 0
AS 
BEGIN 
 New.RECORDID=gen_id(RECORDID_GENERATOR,1);
END^
SET TERM ; ^
SET TERM ^ ;
CREATE TRIGGER RECORDIDLUOPERATINGSYSTEMS FOR LUOPERATINGSYSTEMS ACTIVE
BEFORE INSERT POSITION 0
AS 
BEGIN 
 New.RECORDID=gen_id(RECORDID_GENERATOR,1);
END^
SET TERM ; ^
SET TERM ^ ;
CREATE TRIGGER RECORDIDOTHEREQUIPMENT FOR OTHEREQUIPMENT ACTIVE
BEFORE INSERT POSITION 0
AS 
BEGIN 
 New.RECORDID=gen_id(RECORDID_GENERATOR,1);
END^
SET TERM ; ^

SET TERM ^ ;
ALTER PROCEDURE DELETELUDEPARTMENTS (
    RECORDID Integer,
    UOC Varchar(20) )
RETURNS (
    RETURNMESSAGE Varchar(255) )
AS
BEGIN 
 Execute Procedure VALIDATEVARCHARFIELDASNOTBLANK(UOC,'UOC') returning_values ReturnMessage; 
 if (ReturnMessage='OK') then
  begin
   update LUDepartments    
   set RECORDSTATUS='D', 
       UOC=:UOC,
       DOC=Current_timestamp
   where RecordID=:RecordID;
   if (row_count=0) then    
    ReturnMessage='ERROR: RecordID of ' || :RecordID || ' does not exist';  
   suspend;   
   ReturnMessage='OK';
  end
 
 suspend;
END^
SET TERM ; ^


SET TERM ^ ;
ALTER PROCEDURE DELETELUMANUFACTURERCPUSPEEDS (
    RECORDID Integer,
    UOC Varchar(20) )
RETURNS (
    RETURNMESSAGE Varchar(255) )
AS
BEGIN 
 Execute Procedure VALIDATEVARCHARFIELDASNOTBLANK(UOC,'UOC') returning_values ReturnMessage; 
 if (ReturnMessage='OK') then
  begin
   update LUMANUFACTURERCPUSPEEDS    
   set RECORDSTATUS='D', 
       UOC=:UOC,
       DOC=Current_timestamp
   where RecordID=:RecordID;
   if (row_count=0) then    
    ReturnMessage='ERROR: RecordID of ' || :RecordID || ' does not exist';  
   suspend;   
   ReturnMessage='OK';
  end
 
 suspend;
END^
SET TERM ; ^


SET TERM ^ ;
ALTER PROCEDURE FETCHLUDEPARTMENTS (
    RECORDID Integer )
RETURNS (
    CODE Varchar(3),
    DESCRIPTION Varchar(40),
    RECORDSTATUS Varchar(1),
    UOE Varchar(20),
    DOE Timestamp,
    UOC Varchar(20),
    DOC Timestamp )
AS
BEGIN
	FOR SELECT a.Code,a.Description, a.UOE, a.DOE, a.UOC, a.DOC, a.RECORDSTATUS
	    FROM LUDepartments a
	    Where a.RecordID=:RecordID
	    INTO :Code,:Description, :UOE, :DOE, :UOC, :DOC, :RECORDSTATUS
	DO
	BEGIN
		SUSPEND;
	END
END^
SET TERM ; ^


SET TERM ^ ;
ALTER PROCEDURE FETCHLUMANUFACTURERCPUSPEEDS (
    RECORDID Integer )
RETURNS (
    MANUFACTURERCPUSPEED Varchar(60),
    RECORDSTATUS Varchar(1),
    UOE Varchar(20),
    DOE Timestamp,
    UOC Varchar(20),
    DOC Timestamp )
AS
BEGIN
	FOR SELECT a.MANUFACTURERCPUSPEED, a.UOE, a.DOE, a.UOC, a.DOC, a.RECORDSTATUS
	    FROM LUMANUFACTURERCPUSPEEDS a
	    Where a.RecordID=:RecordID
	    INTO :MANUFACTURERCPUSPEED, :UOE, :DOE, :UOC, :DOC, :RECORDSTATUS
	DO
	BEGIN
		SUSPEND;
	END
END^
SET TERM ; ^


SET TERM ^ ;
ALTER PROCEDURE INSERTLUDEPARTMENTS (
    CODE Varchar(3),
    DESCRIPTION Varchar(40),
    RECORDSTATUS Varchar(1),
    UOE Varchar(20) )
RETURNS (
    RETURNMESSAGE Varchar(255) )
AS
DECLARE VARIABLE RecordID Integer;
BEGIN 
 --Returnmessage='OK';
 Execute Procedure ValidateLUDepartments(Code,Description,RecordStatus,UOE) returning_values ReturnMessage; 
 if (ReturnMessage='OK') then
  begin
   INSERT INTO LUDepartments (Code, Description, UOE, DOE, RECORDSTATUS)
        VALUES (:Code, :Description, :UOE, current_timestamp,:RecordStatus)
   returning RecordID into RecordID;
   suspend;   
   ReturnMessage='OK RecordID: ' || Cast(RecordID as varchar(13));
   When sqlcode -802 do ReturnMessage='ERROR: Insert Failed.  LUDepartments of ' || Description || ' is already in the datatabase';
   When sqlcode -803 do ReturnMessage='ERROR: Insert Failed.  LUDepartments of ' || Code || ' is already in the datatabase';
  end
 --ReturnMessage='TEST';
 suspend;
END^
SET TERM ; ^


SET TERM ^ ;
ALTER PROCEDURE INSERTLUMANUFACTURERCPUSPEEDS (
    MANUFACTURERCPUSPEED Varchar(60),
    RECORDSTATUS Varchar(1),
    UOE Varchar(20) )
RETURNS (
    RETURNMESSAGE Varchar(255) )
AS
DECLARE VARIABLE RecordID Integer;
BEGIN 
 --Returnmessage='OK';
 Execute Procedure ValidateLUManufacturerCPUSpeeds(ManufacturerCPUSpeed,RecordStatus,UOE) returning_values ReturnMessage; 
 if (ReturnMessage='OK') then
  begin
   INSERT INTO LUMANUFACTURERCPUSPEEDS (MANUFACTURERCPUSPEED, UOE, DOE, RECORDSTATUS)
        VALUES (:MANUFACTURERCPUSPEED, :UOE, current_timestamp,:RecordStatus)
   returning RecordID into RecordID;
   suspend;   
   ReturnMessage='OK RecordID: ' || Cast(RecordID as varchar(13));
   When sqlcode -803 do ReturnMessage='ERROR: Insert Failed.  ManufacturerCPUSpeed Value of ' || ManufacturerCPUSpeed || ' is already in the datatabase';
  end
 --ReturnMessage='TEST';
 suspend;
END^
SET TERM ; ^


SET TERM ^ ;
ALTER PROCEDURE SELECTLUDEPARTMENTS
RETURNS (
    CODE Varchar(3),
    DESCRIPTION Varchar(40),
    RECORDSTATUS Varchar(1),
    UOE Varchar(20),
    DOE Timestamp,
    UOC Varchar(20),
    DOC Timestamp,
    RECORDID Integer )
AS
BEGIN
	FOR SELECT a.Code, a.Description, a.RECORDID, a.UOE, a.DOE, a.UOC, a.DOC, a.RECORDSTATUS
	    FROM LUDepartments a
	    INTO :Code, :Description, :RECORDID, :UOE, :DOE, :UOC, :DOC, :RECORDSTATUS
	DO
	BEGIN
		SUSPEND;
	END
END^
SET TERM ; ^


SET TERM ^ ;
ALTER PROCEDURE SELECTLUMANUFACTURERCPUSPEEDS
RETURNS (
    MANUFACTURERCPUSPEED Varchar(60),
    RECORDSTATUS Varchar(1),
    UOE Varchar(20),
    DOE Timestamp,
    UOC Varchar(20),
    DOC Timestamp,
    RECORDID Integer )
AS
BEGIN
	FOR SELECT a.MANUFACTURERCPUSPEED, a.RECORDID, a.UOE, a.DOE, a.UOC, a.DOC, a.RECORDSTATUS
	    FROM LUMANUFACTURERCPUSPEEDS a
	    INTO :MANUFACTURERCPUSPEED, :RECORDID, :UOE, :DOE, :UOC, :DOC, :RECORDSTATUS
	DO
	BEGIN
		SUSPEND;
	END
END^
SET TERM ; ^


SET TERM ^ ;
ALTER PROCEDURE UPDATELUDEPARTMENTS (
    RECORDID Integer,
    CODE Varchar(3),
    DESCRIPTION Varchar(40),
    RECORDSTATUS Varchar(1),
    UOC Varchar(20) )
RETURNS (
    RETURNMESSAGE Varchar(255) )
AS
BEGIN 
 Execute Procedure ValidateLUDepartments(Code,Description,RecordStatus,UOC) returning_values ReturnMessage; 
 if (ReturnMessage='OK') then
  begin
   update LUDepartments
   set Code=:Code,
       Description=:Description,
       RECORDSTATUS=:RecordStatus, 
       UOC=:UOC,
       DOC=Current_timestamp
   where RecordID=:RecordID;
   if (row_count=0) then    
    ReturnMessage='ERROR: RecordID of ' || :RecordID || ' does not exist';  
   suspend;   
   ReturnMessage='OK';
   --When sqlcode -802 do ReturnMessage='ERROR: Insert Failed.  LUDepartments of ' || Code || ' is already in the datatabase';
   When sqlcode -803 do ReturnMessage='ERROR: Insert Failed.  LUDepartments of ' || Description || ' is already in the datatabase';
  end
 
 suspend;
END^
SET TERM ; ^


SET TERM ^ ;
ALTER PROCEDURE UPDATELUMANUFACTURERCPUSPEEDS (
    RECORDID Integer,
    MANUFACTURERCPUSPEED Varchar(60),
    RECORDSTATUS Varchar(1),
    UOC Varchar(20) )
RETURNS (
    RETURNMESSAGE Varchar(255) )
AS
BEGIN 
 Execute Procedure ValidateLUManufacturerCPUSpeeds(ManufacturerCPUSpeed,RecordStatus,UOC) returning_values ReturnMessage; 
 if (ReturnMessage='OK') then
  begin
   update LUMANUFACTURERCPUSPEEDS 
   set MANUFACTURERCPUSPEED=:MANUFACTURERCPUSPEED,
       RECORDSTATUS=:RecordStatus, 
       UOC=:UOC,
       DOC=Current_timestamp
   where RecordID=:RecordID;
   if (row_count=0) then    
    ReturnMessage='ERROR: RecordID of ' || :RecordID || ' does not exist';  
   suspend;   
   ReturnMessage='OK';
   When sqlcode -803 do ReturnMessage='ERROR: Update Failed.  ManufacturerCPUSpeed Value of ' || ManufacturerCPUSpeed || ' is already in the datatabase';
  end
 
 suspend;
END^
SET TERM ; ^


SET TERM ^ ;
ALTER PROCEDURE VALIDATELUDEPARTMENTS (
    CODE Varchar(3),
    DESCRIPTION Varchar(40),
    RECORDSTATUS Varchar(1),
    USERID Varchar(20) )
RETURNS (
    RETURNMESSAGE Varchar(255) )
AS
DECLARE VARIABLE RecordID Integer;
BEGIN 
 Execute Procedure VALIDATEVARCHARFIELDASNOTBLANK(Code,'Code') returning_values ReturnMessage; 
 if (ReturnMessage='OK') then
  Begin
  Execute Procedure VALIDATEVARCHARFIELDASNOTBLANK(Description,'Description') returning_values ReturnMessage; 
  if (ReturnMessage='OK') then  
   begin
   Execute Procedure VALIDATERECORDSTATUS(RecordStatus) returning_values ReturnMessage;
   if (ReturnMessage='OK') then
    begin
     Execute Procedure VALIDATEVARCHARFIELDASNOTBLANK(UserID,'UserID') returning_values ReturnMessage; 
    end   
   end 
  end 
 Suspend;
END^
SET TERM ; ^


SET TERM ^ ;
ALTER PROCEDURE VALIDATELUMANUFACTURERCPUSPEEDS (
    MANUFACTURERCPUSPEEDS Varchar(60),
    RECORDSTATUS Varchar(1),
    USERID Varchar(20) )
RETURNS (
    RETURNMESSAGE Varchar(255) )
AS
DECLARE VARIABLE RecordID Integer;
BEGIN 
 Execute Procedure VALIDATEVARCHARFIELDASNOTBLANK(ManufacturerCPUSpeeds,'ManufacturerCPUSpeed') returning_values ReturnMessage; 
 if (ReturnMessage='OK') then
  begin
  Execute Procedure VALIDATERECORDSTATUS(RecordStatus) returning_values ReturnMessage;
  if (ReturnMessage='OK') then
   begin
    Execute Procedure VALIDATEVARCHARFIELDASNOTBLANK(UserID,'UserID') returning_values ReturnMessage; 
   end   
  end 
 Suspend;
END^
SET TERM ; ^


SET TERM ^ ;
ALTER PROCEDURE VALIDATERECORDSTATUS (
    RECORDSTATUS Varchar(1) )
RETURNS (
    RETURNMESSAGE Varchar(255) )
AS
BEGIN 
 if (RecordStatus='A' or RecordStatus='D' or RecordStatus='I' or RecordStatus='P') then
  ReturnMessage='OK';
 else
  ReturnMessage='ERROR: Value For RecordStatus Must Be P,A,I,D';
 suspend;
END^
SET TERM ; ^


SET TERM ^ ;
ALTER PROCEDURE VALIDATEVARCHARFIELDASNOTBLANK (
    FIELDTOVALIDATE Varchar(255),
    FIELDNAME Varchar(80) )
RETURNS (
    RETURNMESSAGE Varchar(255) )
AS
BEGIN 
 if (FieldToValidate='' or FieldToValidate is null) then
  Begin
  ReturnMessage='ERROR: Must Enter A Value For ' || FieldName;
  End
 else
  Begin
  ReturnMessage='OK';
  End
  suspend;
END^
SET TERM ; ^


CREATE UNIQUE INDEX IX_COMPUTERS_COMPUTERNAME ON COMPUTERS (COMPUTERNAME);
CREATE INDEX IDX_COMPUTERSSOFTWARE_SWNAME ON COMPUTERSSOFTWARE (SOFTWARENAME);
CREATE UNIQUE INDEX IX_COMPUTERSSOFTWARE_COM ON COMPUTERSSOFTWARE (COMPUTERSRECORDID,SOFTWARENAME);
CREATE UNIQUE INDEX IX_CONF_RECORDID ON CONFIGURATIONS (RECORDID);
CREATE INDEX IX_CONF_VCONSQLSN ON CONFIGURATIONS (VCONSQLSNRECORDID);
CREATE INDEX IX_CONFACT_CONRECORDID ON CONFIGURATIONSACTIONS (CONRECORDID);
CREATE INDEX IX_CONFACT_TITLE ON CONFIGURATIONSACTIONS (TITLE);
CREATE INDEX IX_CONFIGFIELD_CONRECORDID ON CONFIGURATIONSFIELDMAPPING (CONRECORDID);
CREATE UNIQUE INDEX IX_CONFIGURATIONSUF_RECORDID ON CONFIGURATIONSUPDATEFORMS (RECORDID);
CREATE INDEX IX_CONFIGUFF_CUFRECORDID ON CONFIGURATIONUPDATEFORMFIELD (CUFRECORDID);
CREATE UNIQUE INDEX IX_LUDEPARTMENTS_DESCRIPTION ON LUDEPARTMENTS (DESCRIPTION);
CREATE UNIQUE INDEX IX_LUDEPARTMENTS_RECORDID ON LUDEPARTMENTS (RECORDID);
CREATE UNIQUE INDEX IX_LUGHOSTIMAGES_RECORDID ON LUGHOSTIMAGES (RECORDID);
CREATE INDEX IX_LUGHOSTIMAGES_WHEREIMAGE ON LUGHOSTIMAGES (WHEREIMAGEISKEPT);
CREATE UNIQUE INDEX IX_LULOCATIONS_RECORDID ON LULOCATIONS (RECORDID);
CREATE UNIQUE INDEX IX_LULOOKUPBUTTONCALL_RECORDID ON LULOOKUPBUTTONCALL (RECORDID);
CREATE UNIQUE INDEX IX_LUMANUFACTURERCPUSPEEDS_ID ON LUMANUFACTURERCPUSPEEDS (RECORDID);
CREATE UNIQUE INDEX IX_LUOPERATINGSYSTEMS_RECORDID ON LUOPERATINGSYSTEMS (RECORDID);
CREATE UNIQUE INDEX IX_LUSOFTWAREONPCSNAMES_ID ON LUSOFTWAREONPCSNAMES (RECORDID);
CREATE UNIQUE INDEX IX_LUVALIDATIONRULE_RECORDID ON LUVALIDATIONRULE (RECORDID);
CREATE INDEX IX_UPDATEFORMSLOOKS_CUFRI_NAME ON UPDATEFORMSLOOKS (CUFRECORDID,NAME);
CREATE UNIQUE INDEX IX_UPDATEFORMSLOOKS_RECORDID ON UPDATEFORMSLOOKS (RECORDID);
CREATE UNIQUE INDEX IX_UPDATEFORMSLF_UFLID_FNAME ON UPDATEFORMSLOOKSFIELDS (UPDATEFORMSLOOKSRECORDID,FIELDNAME);
CREATE UNIQUE INDEX IX_VCONFSQLSELECT_RECORDID ON VCONFSQLSELECTSTATEMENT (RECORDID);
GRANT EXECUTE
 ON PROCEDURE DELETELUDEPARTMENTS TO  PCINVAPP;

GRANT EXECUTE
 ON PROCEDURE DELETELUMANUFACTURERCPUSPEEDS TO  PCINVAPP;

GRANT EXECUTE
 ON PROCEDURE FETCHLUDEPARTMENTS TO  PCINVAPP;

GRANT EXECUTE
 ON PROCEDURE FETCHLUMANUFACTURERCPUSPEEDS TO  PCINVAPP;

GRANT EXECUTE
 ON PROCEDURE INSERTLUDEPARTMENTS TO  PCINVAPP;

GRANT EXECUTE
 ON PROCEDURE INSERTLUMANUFACTURERCPUSPEEDS TO  PCINVAPP;

GRANT EXECUTE
 ON PROCEDURE SELECTLUDEPARTMENTS TO  PCINVAPP;

GRANT EXECUTE
 ON PROCEDURE SELECTLUMANUFACTURERCPUSPEEDS TO  PCINVAPP;

GRANT EXECUTE
 ON PROCEDURE SELECTLUMANUFACTURERCPUSPEEDS TO  PCINVAPPREADONLY;

GRANT EXECUTE
 ON PROCEDURE UPDATELUDEPARTMENTS TO  PCINVAPP;

GRANT EXECUTE
 ON PROCEDURE UPDATELUMANUFACTURERCPUSPEEDS TO  PCINVAPP;

GRANT EXECUTE
 ON PROCEDURE VALIDATELUDEPARTMENTS TO  PCINVAPP;

GRANT EXECUTE
 ON PROCEDURE VALIDATELUMANUFACTURERCPUSPEEDS TO  PCINVAPP;

GRANT EXECUTE
 ON PROCEDURE VALIDATERECORDSTATUS TO  PCINVAPP;

GRANT EXECUTE
 ON PROCEDURE VALIDATEVARCHARFIELDASNOTBLANK TO  PCINVAPP;

GRANT DELETE, INSERT, REFERENCES, SELECT, UPDATE
 ON COMPUTERS TO  PCINVAPP WITH GRANT OPTION;

GRANT SELECT
 ON COMPUTERS TO  PCINVAPPREADONLY WITH GRANT OPTION;

GRANT DELETE, INSERT, REFERENCES, SELECT, UPDATE
 ON COMPUTERSSOFTWARE TO  PCINVAPP WITH GRANT OPTION;

GRANT DELETE, INSERT, REFERENCES, SELECT, UPDATE
 ON CONFIGURATIONS TO  PCINVAPP WITH GRANT OPTION;

GRANT DELETE, INSERT, REFERENCES, SELECT, UPDATE
 ON CONFIGURATIONSACTIONS TO  PCINVAPP WITH GRANT OPTION;

GRANT DELETE, INSERT, REFERENCES, SELECT, UPDATE
 ON CONFIGURATIONSFIELDMAPPING TO  PCINVAPP WITH GRANT OPTION;

GRANT DELETE, INSERT, REFERENCES, SELECT, UPDATE
 ON CONFIGURATIONSUPDATEFORMS TO  PCINVAPP WITH GRANT OPTION;

GRANT DELETE, INSERT, REFERENCES, SELECT, UPDATE
 ON CONFIGURATIONUPDATEFORMFIELD TO  PCINVAPP WITH GRANT OPTION;

GRANT DELETE, INSERT, REFERENCES, SELECT, UPDATE
 ON LUDEPARTMENTS TO  PCINVAPP WITH GRANT OPTION;

GRANT DELETE, INSERT, REFERENCES, SELECT, UPDATE
 ON LUDIVISIONS TO  PCINVAPP WITH GRANT OPTION;

GRANT DELETE, INSERT, REFERENCES, SELECT, UPDATE
 ON LUGHOSTIMAGES TO  PCINVAPP WITH GRANT OPTION;

GRANT DELETE, INSERT, REFERENCES, SELECT, UPDATE
 ON LULOCATIONS TO  PCINVAPP WITH GRANT OPTION;

GRANT DELETE, INSERT, REFERENCES, SELECT, UPDATE
 ON LULOOKUPBUTTONCALL TO  PCINVAPP WITH GRANT OPTION;

GRANT DELETE, INSERT, REFERENCES, SELECT, UPDATE
 ON LUMANUFACTURERCPUSPEEDS TO  PCINVAPP WITH GRANT OPTION;

GRANT SELECT
 ON LUMANUFACTURERCPUSPEEDS TO  PCINVAPPREADONLY;

GRANT DELETE, INSERT, REFERENCES, SELECT, UPDATE
 ON LUOPERATINGSYSTEMS TO  PCINVAPP WITH GRANT OPTION;

GRANT DELETE, INSERT, REFERENCES, SELECT, UPDATE
 ON LUSOFTWAREONPCSNAMES TO  PCINVAPP WITH GRANT OPTION;

GRANT DELETE, INSERT, REFERENCES, SELECT, UPDATE
 ON LUVALIDATIONRULE TO  PCINVAPP WITH GRANT OPTION;

GRANT DELETE, INSERT, REFERENCES, SELECT, UPDATE
 ON OTHEREQUIPMENT TO  PCINVAPP WITH GRANT OPTION;

GRANT DELETE, INSERT, REFERENCES, SELECT, UPDATE
 ON SQLTEMP TO  PCINVAPP WITH GRANT OPTION;

GRANT SELECT
 ON SQLTEMP TO  PCINVAPPREADONLY;

GRANT DELETE, INSERT, REFERENCES, SELECT, UPDATE
 ON UPDATEFORMSLOOKS TO  PCINVAPP WITH GRANT OPTION;

GRANT DELETE, INSERT, REFERENCES, SELECT, UPDATE
 ON UPDATEFORMSLOOKSFIELDS TO  PCINVAPP WITH GRANT OPTION;

GRANT DELETE, INSERT, REFERENCES, SELECT, UPDATE
 ON VCONFSQLSELECTSTATEMENT TO  PCINVAPP WITH GRANT OPTION;

